/***************************************************************************
                          c_user_to_lock_out.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_user_to_lock_out.h,v 1.15 2008/03/25 12:04:24 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_user_to_lock_out'
    \version $Id: c_user_to_lock_out.h,v 1.15 2008/03/25 12:04:24 ghostvoodooman Exp $
*/

#ifndef C_USER_TO_LOCK_OUT_H__
#define C_USER_TO_LOCK_OUT_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

/*!
    \brief Stores information about locked out users due to bad logins
    \author VooDooMan
    \version 1
    \date 2005
*/
class c_user_to_lock_out
{
public:
    my_time_t timestamp;                           //!< Timestamp of bad log in
    string remote;                              //!< Remote host/IP
};

#endif

