/***************************************************************************
                          c_foreach.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_foreach.h,v 1.14 2008/03/11 21:11:37 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_foreach'
    \version $Id: c_foreach.h,v 1.14 2008/03/11 21:11:37 ghostvoodooman Exp $
*/

#ifndef c_foreach_H__
#define c_foreach_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../microcode_shared.h"
#include "../variable.h"

struct c_foreach
{
    var_sym_index_t what;
    string key;
    string value;
    MY_U_LONG_LONG foreach_iterator;
    bool ref_value;

    var_sym_index_t value_index;

    string debug;

    long end_loop_id;

    var_id_t reference;

    void clear();
};

#endif

