/***************************************************************************
                          c_channel_def.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_channel_def.cpp,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_channel_def'
    \version $Id: c_channel_def.cpp,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_channel_def.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_channel_def::c_channel_def()
{
    last_changed=0;
}

void c_channel_def::clear()
{
    channel_name="";
    on_mode="";
    on_key="";
    on_limit="";
    on_topic="";
    on_dynamic_ban="";
    allow_dynamic.clear();
    dynamic_plus_modes="";
    dynamic_minus_modes="";
    on_ircop="";
    on_privmsg="";
    on_notice="";
    on_part="";
    on_dynamic_ban="";
    on_ctcp="";
    on_server_msg="";
    groups.clear();
    replication.clear();
    last_changed=0;
    keys.clear();
    dynamic_bans.clear();
}

