/* $Id: mdump.h,v 1.28 2008/03/11 21:11:40 ghostvoodooman Exp $ */

/*

URL: http://www.codeproject.com/debug/postmortemdebug_standalone1.asp

Article content copyright Andy Pennell, 2002

This file was downloaded as part of article at above URL.
This file copyright Andy Pennell, 2002

Modified by Marian VooDooMan Meravy for purposes of VooDoo cIRCle IRC bot.

*/

#ifndef MDUMP_H__
#define MDUMP_H__

#if defined(_MSC_VER)   // other compilers produce binary with incompatible symbols

#include <windows.h>

#if defined(_MSC_VER)

#if _MSC_VER < 1300
#define DECLSPEC_DEPRECATED
// VC6: change this path to your Platform SDK headers
#include "M:\\dev7\\vs\\devtools\\common\\win32sdk\\include\\dbghelp.h"            // must be XP version of file
#else
// VC7: ships with updated headers
#include "DbgHelp.h"
#endif

#else    // defined(_MSC_VER)

#include <DbgHelp.h>

#include "dbgdefines.h"

#endif   // defined(_MSC_VER)

// based on dbghelp.h
typedef BOOL (WINAPI *MINIDUMPWRITEDUMP)(HANDLE hProcess, DWORD dwPid, HANDLE hFile, MINIDUMP_TYPE DumpType,
                                    CONST PMINIDUMP_EXCEPTION_INFORMATION ExceptionParam,
                                    CONST PMINIDUMP_USER_STREAM_INFORMATION UserStreamParam,
                                    CONST PMINIDUMP_CALLBACK_INFORMATION CallbackParam
                                    );

class MiniDumper
{
private:
    static LPCSTR m_szAppName;

public:
    MiniDumper(const char* timestamp);
    ~MiniDumper();

    static LONG WINAPI TopLevelFilter( struct _EXCEPTION_POINTERS *pExceptionInfo );
};

#else   // defined(_WIN32)
class MiniDumper { public: MiniDumper(const char* timestamp); };
#endif  // defined(_MSC_VER)
#endif

