/***************************************************************************
                          c_micro_update.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_micro_update.cpp,v 1.14 2008/03/11 21:11:45 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_micro_update'
    \version $Id: c_micro_update.cpp,v 1.14 2008/03/11 21:11:45 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_micro_update.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_micro_update::c_micro_update(const c_micro_update& orig)
    : c_micro(orig)
{
    input_=orig.input_;
    var_name_=orig.var_name_;
}

c_micro* c_micro_update::copy()
{
    return MY_NEW c_micro_update(*this);
}

var_sym_index_t c_micro_update::get_output()
{
    return VAR_SYM_INDEX_NONE;
}

void c_micro_update::add_inputs(vector<var_sym_index_t>& UNUSEDARG(inputs))
{
    // do not add input_
}

void c_micro_update::optimize_output(const vector<var_sym_index_t>& UNUSEDARG(inputs))
{
    // do not add input_
}

