/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2006  Marian VooDooMan Meravy
                         (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "control.h"

#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

Tvdcsvc *vdcsvc;
//---------------------------------------------------------------------------
__fastcall Tvdcsvc::Tvdcsvc(TComponent* Owner)
	: TService(Owner)
{
}

TServiceController __fastcall Tvdcsvc::GetServiceController(void)
{
	return (TServiceController) ServiceController;
}

void __stdcall ServiceController(unsigned CtrlCode)
{
	vdcsvc->Controller(CtrlCode);
}
//---------------------------------------------------------------------------
void __fastcall Tvdcsvc::ServiceStart(TService *Sender, bool &Started)
{
    srand(time(NULL));
    Timer2->Interval=5000+rand()%10000;
    Timer2->Enabled=true;
    Started=true;
}
//---------------------------------------------------------------------------
void __fastcall Tvdcsvc::ServiceStop(TService *Sender, bool &Stopped)
{
    Timer2->Enabled=false;
    stop();
    Stopped=true;
}
//---------------------------------------------------------------------------
void __fastcall Tvdcsvc::Timer1Timer(TObject *Sender)
{
    loop();
}
//---------------------------------------------------------------------------
void svc_stop()
{
    bool Stopped;
    vdcsvc->ServiceStop(vdcsvc,Stopped);
}
//---------------------------------------------------------------------------

void __fastcall Tvdcsvc::Timer2Timer(TObject *Sender)
{
    FILE* f=fopen("c:\\vdc.txt","r");
    //FILE* f=fopen(".\\vdc.txt","r");      // for DEBUG purpose only!
    if(!f)
        return;

    Timer2->Interval=1000;

    while(!feof(f)) {
        char path[1024+16];
        path[0]=0;
        fgets(path,1024,f);

        if(strlen(path) && (path[strlen(path)-1]=='\r' || path[strlen(path)-1]=='\n'))
            path[strlen(path)-1]=0;
        if(strlen(path) && (path[strlen(path)-1]=='\r' || path[strlen(path)-1]=='\n'))
            path[strlen(path)-1]=0;

        if(strlen(path)) {
            char seconds[1024+16];
            seconds[0]=0;
            fgets(seconds,1024,f);
            init(path,atol(seconds));
            fgets(seconds,1024,f); // erase "."
        }
    }

    fclose(f);

    start();
}
//---------------------------------------------------------------------------

