/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2006  Marian VooDooMan Meravy
                         (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::ServiceProcess;
using namespace System::ComponentModel;

#include "control.h"


namespace vdcsvc
{
    /// <summary> 
    /// Summary for vdcsvcWinService
    /// </summary>
    ///
    /// WARNING: If you change the name of this class, you will need to change the 
    ///          'Resource File Name' property for the managed resource compiler tool 
    ///          associated with all .resx files this class depends on.  Otherwise,
    ///          the designers will not be able to interact properly with localized
    ///          resources associated with this form.
    public __gc class vdcsvcWinService : public System::ServiceProcess::ServiceBase 
    {
    public:
        vdcsvcWinService()
        {
            InitializeComponent();    
        }
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        void Dispose(bool disposing)
        {
            if (disposing && components)
            {
                components->Dispose();
            }
            __super::Dispose(disposing);
        }
        
    protected:
        /// <summary>
        /// Set things in motion so your service can do its work.
        /// </summary>
        void OnStart(String* args[])
        {
            FILE* f=fopen("c:\\vdc.txt","r");
            if(!f)
                return;

            while(!feof(f)) {
                char path[1024+16];
                path[0]=0;
                fgets(path,1024,f);

                if(strlen(path) && (path[strlen(path)-1]=='\r' || path[strlen(path)-1]=='\n'))
                    path[strlen(path)-1]=0;
                if(strlen(path) && (path[strlen(path)-1]=='\r' || path[strlen(path)-1]=='\n'))
                    path[strlen(path)-1]=0;
    
                if(strlen(path)) {
                    char seconds[1024+16];
                    seconds[0]=0;
                    fgets(seconds,1024,f);
                    init(path,atol(seconds));
                    fgets(seconds,1024,f); // erase "."
                }
            }

            fclose(f);

            start();
        }
        
        /// <summary>
        /// Stop this service.
        /// </summary>
        void OnStop()
        {     
            stop();
        }
    private: System::Timers::Timer *  timer1;

    private:
        /// <summary>
        /// Required designer variable.
        /// </summary>
        System::ComponentModel::Container *components;

        /// <summary> 
        /// Required method for Designer support - do not modify 
        /// the contents of this method with the code editor.
        /// </summary>    
        void InitializeComponent(void)
        {
            this->timer1 = new System::Timers::Timer();
            (__try_cast<System::ComponentModel::ISupportInitialize *  >(this->timer1))->BeginInit();
            // 
            // timer1
            // 
            this->timer1->Enabled = true;
            this->timer1->Elapsed += new System::Timers::ElapsedEventHandler(this, timer1_Elapsed);
            // 
            // vdcsvc
            // 
            this->ServiceName = S"vdcsvcWinService";
            (__try_cast<System::ComponentModel::ISupportInitialize *  >(this->timer1))->EndInit();

        }        
    private: System::Void timer1_Elapsed(System::Object *  sender, System::Timers::ElapsedEventArgs *  e)
             {
                 loop();
             }

    };
}