/***************************************************************************
                          compress.cpp  -  description
                             -------------------
    begin                : Mon Nov 7 2005
    copyright            : (C) 2005-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: compress.h,v 1.36 2008/03/11 21:11:26 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2005-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Routines for compression
    \version $Id: compress.h,v 1.36 2008/03/11 21:11:26 ghostvoodooman Exp $
*/

#ifndef COMPRESS_H__
#define COMPRESS_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#if defined (_MSC_VER) || defined(__BORLANDC__)
#   include <zlib/include/zlib.h>
#else
#   include <zlib.h>
#endif

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

using namespace std;

string compress_zlib_get_str_rc(int rc);
char* compress_zlib_compress(void *in_buf, unsigned long in_len, unsigned long& out_len, int level, int& rc);
char* compress_zlib_decompress(void *in_buf, size_t in_len, unsigned long& out_len, int& rc);

string compress_get_zlib_version();

#endif

