/***************************************************************************
                          c_dcc_request_whois.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_dcc_request_whois.cpp,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_dcc_request_whois'
    \version $Id: c_dcc_request_whois.cpp,v 1.14 2008/03/11 21:11:33 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_dcc_request_whois.h"

void c_dcc_request_whois::clear()
{
    start=0;
    got_whois=false;
    irc_op=false;
    only_dns=false;
    dns_done=false;

    str.clear();
    nick.clear();
    host_mask.clear();
    ident.clear();
    host.clear();
    full_name.clear();
    resolv4_1.clear();
    resolv4_2.clear();
    resolv6_1.clear();
    resolv6_2.clear();
    comment.clear();
}

c_dcc_request_whois::c_dcc_request_whois()
{
    start=0;
    got_whois=false;
    irc_op=false;
    only_dns=false;
    dns_done=false;
}

