/***************************************************************************
                          c_if_branch.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_if_branch.h,v 1.1 2008/11/24 12:09:23 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_if_branch'
    \version $Id: c_if_branch.h,v 1.1 2008/11/24 12:09:23 ghostvoodooman Exp $
*/

#ifndef c_if_branch_H__
#define c_if_branch_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

/*!
    \brief Implements bunch of "if-else-if-else-..." commands
    \version 1
    \date 2006-01
    \author VooDooMan
*/
class c_if_branch
{
public:
    long if_id;     //!< ID of "if"
    long jump_id;   //!< ID of command after "if" sequence (if some "if" were evaluated as "true")

    /*!
        \brief Constructor
        \version 1
        \date 2006-01
        \author VooDooMan
    */
    c_if_branch();
};

#endif

