/***************************************************************************
                          function.h  -  description
                             -------------------
    begin                : Fri Sep 30 2005
    copyright            : (C) 2005-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: function.h,v 1.36 2008/03/11 21:11:28 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2005-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Functions implementation
    \version $Id: function.h,v 1.36 2008/03/11 21:11:28 ghostvoodooman Exp $
*/

#ifndef FUNCTION_H__
#define FUNCTION_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>

#include <stdio.h>

#include "utils/memleak.h"
#include "utils/assert.h"
#include "utils.h"
#include "params.h"

#include "modules.h"
#include "variable.h"
#include "shared.h"
#include "runtime/c_eval_iteration.h"

using namespace std;

bool eval_function(c_module* this_module, const string& code_str, c_var_array* vars, c_functions& functions, const string& debug, stack<c_eval_iteration>& st);

#endif

