/***************************************************************************
                          c_channel.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_channel.cpp,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_channel'
    \version $Id: c_channel.cpp,v 1.14 2008/03/11 21:11:38 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_channel.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_channel::c_channel()
{
    host_unknown=false;
    is_template=false;
    configured=false;
    can_send_unknown_users=false;
    terminator=false;
}

void c_channel::clear()
{
    username="";
    channel_name="";
    host_unknown=false;
    is_template=false;
    groups.clear();
    on_deop="";
    on_ban="";
    on_unban="";
    on_kick="";
    on_op="";
    on_voice="";
    on_devoice="";
    on_join="";
    on_banned="";
    on_flood="";
    on_privmsg="";
    on_notice="";
    on_except="";
    on_unexcept="";
    on_invite="";
    on_uninvite="";
    on_not_invited="";
    on_other_mode="";
    on_other_mode_mask="";
    on_reop="";
    on_not_in_reop="";
    allow_dynamic.clear();
    dynamic_plus_modes="";
    dynamic_minus_modes="";
    configured=false;
    can_send_unknown_users=false;

    terminator=false;
    msg_flood.clear();
    notice_flood.clear();
    repeat_flood.clear();
    nick_flood.clear();
    join_flood.clear();
    mode_flood.clear();
    ctcp_flood.clear();
}

