/***************************************************************************
                          c_procedure.cpp  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_procedure.cpp,v 1.14 2008/03/11 21:11:47 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_procedure'
    \version $Id: c_procedure.cpp,v 1.14 2008/03/11 21:11:47 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../utils/memleak.h"
#include "../utils/assert.h"
#include "../compat.h"

#include "c_procedure.h"
#include "../utils.h"
#include "../utils/precomp.h"

#if defined(_MSC_VER) || defined(__BORLANDC__)
#   pragma hdrstop
#endif

c_procedure::c_procedure()
{
    last_changed=0;
    minimal_botnet_version=1;
    parsed_call_string=false;
    lock_cnt=0;
}

void c_procedure::parse_call_string()
{
    if(parsed_call_string)
        return;
    name_only=name;
    if(name_only.find("(",0)!=string::npos)
        name_only.erase(name_only.find("(",0),name_only.length()-name_only.find("(",0));

    string rest=name;
    if(rest.find("(",0)!=string::npos)
        rest.erase(0,rest.find("(",0)+1);
    if(rest.length() && ')'==rest[rest.length()-1])
        rest.erase(rest.length()-1,1);
    args.clear();
    if(!rest.empty())
        explode(rest,',',args);

    parsed_call_string=true;
}

