/***************************************************************************
                          c_delay_link.h  -  description
                             -------------------
    begin                : Thu May 10 2007
    copyright            : (C) 2004-2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: c_delay_link.h,v 1.14 2008/03/11 21:11:47 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Class 'c_delay_link'
    \version $Id: c_delay_link.h,v 1.14 2008/03/11 21:11:47 ghostvoodooman Exp $
*/

#ifndef C_DELAY_LINK_H__
#define C_DELAY_LINK_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <string>
#include <vector>
#include <stack>
#include <list>
#include <map>
#include <algorithm>

#include "../utils/memleak.h"

#include "../params.h"

#include "../var/c_var_array.h"
#include "../mod/c_module.h"

/*!
    \brief Stores delayed link to remote bot
    \author VooDooMan
    \version 2
    \date 2005-12-08, 2006-01-21
*/
class c_delay_link
{
public:
    string botname;
    string localip;
    string bot_host;
    unsigned short botport;
    string remote_MD5_password;
    string bot_link_type;
    string unlink_proc;
    c_var_array* vars;
    c_module* this_module;

    c_delay_link();
};

#endif

