/***************************************************************************
                          sock_garbage.cpp  -  description
                             -------------------
    begin                : Thu Mar 22 2007
    copyright            : (C) 2007 by Marian VooDooMan Meravy
    email                : ghostvoodooman -a.T= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: sock_garbage.h,v 1.16 2008/03/11 21:11:31 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2007-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -a.T= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Provides garbaging of closed socket connections
    \version $Id: sock_garbage.h,v 1.16 2008/03/11 21:11:31 ghostvoodooman Exp $
*/

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include <list>

#if defined(HAVE_MALLOC_H)
#include <malloc.h>
#endif

#include "utils.h"      // because we want to enable mem leak detection

#include "params.h"

#include "sock.h"
#include "threads.h"
#include "ssl.h"

using namespace std;

#ifndef SOCK_GARBAGE__
#define SOCK_GARBAGE__

void sock_garbage_push(threaded_connect_id &id, c_socket& s, c_ssl* &ssl);
void sock_garbage_loop();

#endif

