/***************************************************************************
                          prologue.h  -  description
                             -------------------
    begin                : Mon Oct 27 2008
    copyright            : (C) 2008 by Marian VooDooMan Meravy
    email                : ghostvoodooman -aT= users (dot) sourceforge.net
 ***************************************************************************/

/* $Id: prologue.h,v 1.1 2008/11/24 12:09:46 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008 by Marian VooDooMan Meravy
  (ghostvoodooman -aT= users (dot) sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Prologue header to include headers that needs to be included at
        beginning of each file
    \version $Id: prologue.h,v 1.1 2008/11/24 12:09:46 ghostvoodooman Exp $
*/

//---------------------------------------------------------------------------

#ifndef PROLOGUE_H__
#define PROLOGUE_H__

#if defined(HAVE_CONFIG_H)
#   include <config.h>
#endif

#include "../params.h"
#include "../memory/memleak.h"
#include "../log2.h"
#include "my_inttypes.h"
#include "../compat.h"
#include "assert.h"
#include "../utils.h"

#endif

