/***************************************************************************
                          log.h  -  description
                             -------------------
    begin                : Thu Dec 9 2004
    copyright            : (C) 2004-2006 by VooDooMan
    email                : ghostvoodooman@users.sourceforge.net
 ***************************************************************************/

/* $Id: log.h,v 1.29 2008/03/11 21:11:50 ghostvoodooman Exp $ */

/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2008  Marian VooDooMan Meravy
                         (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

/*!
    \file
    \brief Dummy file
*/

#ifndef __LOG_H__
#define __LOG_H__

#include <string>

using namespace std;

struct s_socket;

void log_socket(int sock_error, const char* os_msg, const char* msg, s_socket* socket, bool log_anyway = false);
void log_socket(int sock_error, string& os_msg, string& msg, s_socket* socket, bool log_anyway = false);
void log_debug(const char* msg, bool log_anyway = false);
void log_debug(string& msg, bool log_anyway = false);
void log_bot(const char* msg, bool log_anyway = false);
void log_bot(string& msg, bool log_anyway = false);

#endif
