/***************************************************************************

VooDoo cIRCle - an IRC (ro)bot
Copyright (C) 2004-2006  Marian VooDooMan Meravy
                         (ghostvoodooman@users.sourceforge.net)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************/

#include <SysUtils.hpp>
#include <SvcMgr.hpp>

//#define _DEBUG_ 1
#ifdef _DEBUG_
#   include "control.h"
#   include "main.h"
#endif

#pragma hdrstop
#define Application Svcmgr::Application
USEFORM("main.cpp", vdcsvc); /* TService: File Type */
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	try
	{
		Application->Initialize();
		Application->CreateForm(__classid(Tvdcsvc), &vdcsvc);
#       ifndef _DEBUG_
        Application->Run();
#       else
        bool b;
        vdcsvc->ServiceStart(NULL,b);
        while(1) {
            {
                tagMSG* m=new tagMSG;
                if(PeekMessage(m, 0, 0, 0, PM_REMOVE)) {
                    if(m->message!=WM_QUIT) {
                        TranslateMessage(m);
                        DispatchMessage(m);
                    }
                }
                delete m;
            }
            loop();
            Sleep(1);
            bool stop=false;
            if(stop)
                vdcsvc->ServiceStop(NULL,b);
        }
#       endif
	}
	catch (Exception &exception)
	{
		Sysutils::ShowException(&exception, System::ExceptAddr());
	}
        catch(...)
        {
		try
		{
	        	throw Exception("");
		}
		catch(Exception &exception)
		{
			Sysutils::ShowException(&exception, System::ExceptAddr());
		}
        }
	return 0;
}
